{#
/**
 * @file
 * Template for Alert component.
 *
 * Available config:
 * - type: primary | secondary | success | danger | warning | info | light | dark
 * - heading: string,
 * - dimissible: true | false
 * - alert_utility_classes: An array of utility classes.
 */
#}

{#
  Modifications against Radix:
  - Move dismissible to top instead bottom, so :last-child selectors work correctly
  - Add further markup to support alert icons.
#}
{% set alert_attributes = alert_attributes ?: create_attribute() %}
{% set icon_attributes = icon_attributes ?: create_attribute() %}
{% set dismissible = dismissible ?? true %}
{% set type = type ?? 'primary' %}

{%
  set alert_classes = [
    'alert',
    icon_classes ? 'alert--has-icon',
    icon_classes ? 'd-flex',
    icon_classes ? 'gap-2',
    type ? 'alert-' ~ type,
    dismissible ? 'alert-dismissible',
  ]|merge(alert_utility_classes ?: [])
%}

<div {{ alert_attributes.addClass(alert_classes) }} role="alert">
  {% if dismissible %}
    {%
      include 'radix:close-button' with {
        close_button_attributes: create_attribute()
          .setAttribute('data-bs-dismiss', 'alert')
      }
    %}
  {% endif %}
  {% block icon %}
    <div class="alert__icon flex-shrink-0 flex-grow-0">
      <i {{ icon_attributes.addClass(icon_classes) }}></i>
    </div>
  {% endblock %}
  <div class="alert__content flex-shrink-1 flex-grow-1">
    {% block alert_heading %}
      {% if heading %}
        <h4 class="alert-heading">{{ heading }}</h4>
      {% endif %}
    {% endblock %}

    {% block content %}
      <div class="alert-message">
        {{ content }}
      </div>
    {% endblock %}
  </div>
</div>
